diff --git a/gdb/tui/tui-layout.c b/gdb/tui/tui-layout.c
index 7478c2c966a..4869cd9a11a 100644
--- a/gdb/tui/tui-layout.c
+++ b/gdb/tui/tui-layout.c
@@ -80,7 +80,7 @@ show_layout (enum tui_layout_type layout)
 	{
 	  /* First make the current layout be invisible.  */
 	  tui_make_all_invisible ();
-	  tui_make_invisible (tui_locator_win_info_ptr ());
+	  tui_locator_win_info_ptr ()->make_visible (false);
 
 	  switch (layout)
 	    {
@@ -514,7 +514,7 @@ show_source_disasm_command (void)
 			  tui_term_width (),
 			  0,
 			  0);
-      tui_make_visible (TUI_SRC_WIN);
+      TUI_SRC_WIN->make_visible (true);
       TUI_SRC_WIN->m_has_locator = false;
 
       struct tui_locator_window *locator = tui_locator_win_info_ptr ();
@@ -527,14 +527,14 @@ show_source_disasm_command (void)
 			     tui_term_width (),
 			     0,
 			     src_height - 1);
-      tui_make_visible (TUI_DISASM_WIN);
+      TUI_DISASM_WIN->make_visible (true);
       locator->reset (2 /* 1 */ ,
 		      tui_term_width (),
 		      0,
 		      (src_height + asm_height) - 1);
       TUI_SRC_WIN->m_has_locator = false;
       TUI_DISASM_WIN->m_has_locator = true;
-      tui_make_visible (locator);
+      locator->make_visible (true);
       tui_show_locator_content ();
       tui_show_source_content (TUI_DISASM_WIN);
 
@@ -567,7 +567,7 @@ show_data (enum tui_layout_type new_layout)
   data_height = total_height / 2;
   src_height = total_height - data_height;
   tui_make_all_invisible ();
-  tui_make_invisible (locator);
+  locator->make_visible (false);
   if (tui_win_list[DATA_WIN] == nullptr)
     tui_win_list[DATA_WIN] = new tui_data_window ();
   tui_win_list[DATA_WIN]->reset (data_height, tui_term_width (), 0, 0);
@@ -598,7 +598,7 @@ show_data (enum tui_layout_type new_layout)
 		  total_height - 1);
   base->make_visible (true);
   base->m_has_locator = true;
-  tui_make_visible (locator);
+  locator->make_visible (true);
   tui_show_locator_content ();
   tui_add_to_source_windows (base);
   tui_set_current_layout_to (new_layout);
@@ -662,11 +662,11 @@ show_source_or_disasm_and_command (enum tui_layout_type layout_type)
 		       tui_term_width (),
 		       0,
 		       0);
-      tui_make_visible (win_info);
+      win_info->make_visible (true);
 
 
       win_info->m_has_locator = true;
-      tui_make_visible (locator);
+      locator->make_visible (true);
       tui_show_locator_content ();
       tui_show_source_content (win_info);
 
diff --git a/gdb/tui/tui-win.c b/gdb/tui/tui-win.c
index 9d9d9a5f577..c92a706efc6 100644
--- a/gdb/tui/tui-win.c
+++ b/gdb/tui/tui-win.c
@@ -1226,7 +1226,7 @@ tui_adjust_win_heights (struct tui_win_info *primary_win_info,
 void
 tui_source_window_base::set_new_height (int height)
 {
-  tui_make_invisible (execution_info);
+  execution_info->make_visible (false);
   execution_info->height = height;
   execution_info->origin.y = origin.y;
   if (height > 1)
@@ -1238,7 +1238,7 @@ tui_source_window_base::set_new_height (int height)
   if (has_locator ())
     {
       tui_locator_window *gen_win_info = tui_locator_win_info_ptr ();
-      tui_make_invisible (gen_win_info);
+      gen_win_info->make_visible (false);
       gen_win_info->origin.y = origin.y + height;
     }
 }
@@ -1263,7 +1263,7 @@ static void
 make_invisible_and_set_new_height (struct tui_win_info *win_info, 
 				   int height)
 {
-  tui_make_invisible (win_info);
+  win_info->make_visible (false);
   win_info->height = height;
   if (height > 1)
     win_info->viewport_height = height - 1;
@@ -1292,7 +1292,7 @@ tui_win_info::make_visible_with_new_height ()
 void
 tui_source_window_base::do_make_visible_with_new_height ()
 {
-  tui_make_visible (execution_info);
+  execution_info->make_visible (true);
   if (!content.empty ())
     {
       struct tui_line_or_address line_or_addr;
@@ -1326,7 +1326,7 @@ tui_source_window_base::do_make_visible_with_new_height ()
     }
   if (has_locator ())
     {
-      tui_make_visible (tui_locator_win_info_ptr ());
+      tui_locator_win_info_ptr ()->make_visible (true);
       tui_show_locator_content ();
     }
 }
diff --git a/gdb/tui/tui-wingeneral.c b/gdb/tui/tui-wingeneral.c
index 4e6637e8687..2fb8d6c684f 100644
--- a/gdb/tui/tui-wingeneral.c
+++ b/gdb/tui/tui-wingeneral.c
@@ -179,18 +179,6 @@ tui_gen_win_info::make_visible (bool visible)
     }
 }
 
-void
-tui_make_visible (struct tui_gen_win_info *win_info)
-{
-  win_info->make_visible (true);
-}
-
-void
-tui_make_invisible (struct tui_gen_win_info *win_info)
-{
-  win_info->make_visible (false);
-}
-
 /* See tui-data.h.  */
 
 void
diff --git a/gdb/tui/tui-wingeneral.h b/gdb/tui/tui-wingeneral.h
index 20b7f21c7c0..5e6198d4366 100644
--- a/gdb/tui/tui-wingeneral.h
+++ b/gdb/tui/tui-wingeneral.h
@@ -28,8 +28,6 @@ struct tui_win_info;
 struct tui_gen_win_info;
 
 extern void tui_unhighlight_win (struct tui_win_info *);
-extern void tui_make_visible (struct tui_gen_win_info *);
-extern void tui_make_invisible (struct tui_gen_win_info *);
 extern void tui_make_all_visible (void);
 extern void tui_make_all_invisible (void);
 extern void tui_make_window (struct tui_gen_win_info *, enum tui_box);